NumericValue
Date: 2016-07-03

com.icl.saxon.expr

## Class NumericValue

- java.lang.Object
- - com.icl.saxon.expr.Expression
  - - com.icl.saxon.expr.Value
    - - com.icl.saxon.expr.NumericValue

-     public final class NumericValue
      extends Value

  A numeric (floating point) value

- - ### Field Summary

    - ### Fields inherited from class com.icl.saxon.expr.Value

      `ANY, BOOLEAN, NODESET, NUMBER, OBJECT, STRING`

    - ### Fields inherited from class com.icl.saxon.expr.Expression

      `staticContext`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NumericValue(double value)` Constructor supplying a double
    `NumericValue(java.lang.String s)` Constructor supplying a String

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `asBoolean()` Convert the value to a boolean
    `double` | `asNumber()` Get the value as a number
    `java.lang.String` | `asString()` Get the value as a String
    `java.lang.String` | `asStringOLD()` Get the value as a String
    `int` | `conversionPreference(java.lang.Class required)` Get conversion preference for this value to a Java class.
    `java.lang.Object` | `convertToJava(java.lang.Class target)` Convert to Java object (for passing to external functions)
    `void` | `display(int level)` Diagnostic print of expression structure
    `int` | `getDataType()` Determine the data type of the exprssion, if possible

    - ### Methods inherited from class com.icl.saxon.expr.Value

      `compare, equals, evaluate, getDependencies, inverse, notEquals, numericCompare, reduce, simplify, stringToNumber`

    - ### Methods inherited from class com.icl.saxon.expr.Expression

      `containsReferences, enumerate, evaluateAsBoolean, evaluateAsNodeSet, evaluateAsNumber, evaluateAsString, getStaticContext, indent, isContextDocumentNodeSet, make, outputStringValue, setStaticContext, usesCurrent`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NumericValue

          public NumericValue(double value)

      Constructor supplying a double

    - #### NumericValue

          public NumericValue(java.lang.String s)

      Constructor supplying a String

  - ### Method Detail

    - #### asStringOLD

          public java.lang.String asStringOLD()

      Get the value as a String
      Returns:
        a String representation of the value

    - #### asString

          public java.lang.String asString()

      Get the value as a String
      Specified by:
        `asString` in class `Value`
      Returns:
        a String representation of the value

    - #### asNumber

          public double asNumber()

      Get the value as a number
      Specified by:
        `asNumber` in class `Value`
      Returns:
        the numeric value

    - #### asBoolean

          public boolean asBoolean()

      Convert the value to a boolean
      Specified by:
        `asBoolean` in class `Value`
      Returns:
        false if zero, true otherwise

    - #### getDataType

          public int getDataType()

      Determine the data type of the exprssion, if possible
      Specified by:
        `getDataType` in class `Expression`
      Returns:
        one of the values Value.STRING, Value.BOOLEAN, Value.NUMBER, Value.NODESET, Value.FRAGMENT, or Value.ANY (meaning not known in advance)

    - #### conversionPreference

          public int conversionPreference(java.lang.Class required)

      Get conversion preference for this value to a Java class. A low result indicates higher preference.
      Specified by:
        `conversionPreference` in class `Value`

    - #### convertToJava

          public java.lang.Object convertToJava(java.lang.Class target)
                                         throws XPathException

      Convert to Java object (for passing to external functions)
      Specified by:
        `convertToJava` in class `Value`
      Parameters:
        `target` - The class required by the external function
      Returns:
        an object of the target class
      Throws:
        `XPathException`

    - #### display

          public void display(int level)

      Diagnostic print of expression structure
      Specified by:
        `display` in class `Expression`